import es, gamethread, playerlib, popuplib, effectlib, os, math, random, usermsg, langlib

sv_options = {
	'min_players_for_lr': 2,
	'announce_rebel_killed': 1,
	'announce_turn_into_rebel': 1,
	'max_innocent_kills_per_3_seconds': 3,
	'too_high_kps_punishment': 'kick',
	'unrestricted_ct_weapons': 'm4a1,deagle,famas,aug,tmp,knife,vesthelm,vest,nvgs',
	'unrestricted_t_weapons': 'm4a1,deagle,famas,aug,tmp,knife,vesthelm,vest,nvgs',
	't_start_weapons': 'deagle,knife',
	'ct_start_weapons': 'deagle,m4a1',
	'beacon_on_lr': 1,
	'allow_to_kill_for_jumping_on_head': 1,
	'strip_weapons_on_round_end': 0,
	'hosties_rebel_color': '255,255,255,255',
	'hosties_announce_lr_available': 0,
	'hosties_announce_ct_hurt_t': 0,
	'hosties_rebel_on_hurt': 0,
	'hosties_show_rules_on_join': 1,
	'hosties_end_round_at_round_end_time': 1,
	'hosties_change_lr_colors': 0,
	'hosties_round_swap_teams': 0,
	'hosties_teleport_to_designated_areas_for_lr': 1,
	'hosties_enabled_lrs': 'Race,CF,KF,S4S,GT',
	'hosties_make_ct_accept_lr_with_rebel': 1,
	'hosties_silent_commands': 1,
	'hosties_stop_double_drop': 1,
	'hosties_commands': '!lr,!rules,!checkplayers,!commands,!hosties,!control,!checkguns,!wspoint,!setpoints',
	'hosties_enable_chicken_fight_won': 1,
	'hosties_control_command_time': 10,
	'hosties_controller_color': '255,128,0,0',
	'hosties_simon_says_completed_color': '255,0,255,0',
	'hosties_max_more_cts': 2,
	'hosties_control_allow_simon': 1,
	'hosties_enable_control': 1,
	'hosties_enable_noblock': 1,
	'hosties_menu_lang': 'en',
	'hosties_must_accept_lr': 0,
}

es.ServerVar('hosties_version', '2.5', 'Hosties Server Control by Bonbon, Original script by STK#Sebastian').makepublic()
sv = es.ServerVar
hostie_rules = []
rounds = 0
tmik = {}
text = None
menu_lang = 'en'

map_points = {
	'hosties_aztecjail': {
		's4s': [[-1144, 679, 704], [-1146, 5497, 697]],
		'gt': [[-3203, 674, 181], [-3011, 605, 218]]
	},
	'hosties_dustfun': {
		's4s': [[-922, 952, 351], [-936, -890, 351]], 
		'gt': [[1428, 876, 128], [1431, 956, 128]]
	},
	'hosties_dustobey': {
		's4s': [[-922, 952, 351], [-936, -890, 351]], 
		'gt': [[1428, 876, 128], [1431, 956, 128]]
	},
	'hosties_boardwalk': {
		's4s': [[1440, 5962, 348], [-255, 5985, 506]], 
		'gt': [[5300, 3196, 455], [5297, 3233, 455]]
	},
	'hosties_panic3': {
		's4s': [[1246, -946, 64], [-647, -954, 64]],
		'gt': [[-643, 499, 86], [-659, 398, 78]]
	},
	'hosties_antarctica_finale': {
		's4s': [[314, -913, 12], [1513, -914, 12]], 
		'gt': [[354, -601, -83], [355, -657, -83]]
	},
	'hosties_drugfarm_v3': {
		's4s': [[-492, -251, 243], [1125, -251, 243]], 
		'gt': [[-385, 308, 399], [-388, 232, 399]]
	},
	'hosties_dust-town': {
		'gt': [[-292, -880, 0], [-175, -862, 0]]
	},
	'hosties_dusty_v1': {
		's4s': [[1128, 154, 349], [2036, 123, 349]], 
		'gt': [[2070, -1560, 240], [2159, -1560, 241]]
	},
	'hosties_enforce': {
		's4s': [[-2428, -486, 420], [-2420, 2534, 420]],
		'gt': [[-1227, 2441, 129], [-1229, 2350, 128]]
	},
	'hosties_offanesie': {
		's4s': [[204, 383, 128], [1502, 370, 128]], 
		'gt': [[-404, -1159, 281], [-407, -1231, 281]]
	},
	'hosties_prison_1': {
		's4s': [[1575, 1476, 583], [108, 1460, 583]], 
		'gt': [[504, 1454, 718], [375, 1436, 718]]
	},
	'hosties_retrofun_v1': {
		's4s': [[-1986, -751, 128], [-1978, 1235, 128]], 
		'gt': [[-1655, -543, 139], [-1729, -540, 139]]
	},
	'hosties_rocketfight_final': {
		's4s': [[362, -1356, -248], [-1056, -1353, -248]],
		'gt': [[1188, -1541, 95], [1247, -1544, 95]]
	},
	'hosties_stronghold_3': {
		's4s': [[1980, -1178, 353], [1942, -2541, 353]], 
		'gt': [[1688, 197, 608], [1584, 194, 608]]
	},
	'hosties_omen': {
		's4s': [[114, -1930, 120], [141, -764, 96]], 
		'gt': [[427, -271, 320], [421, -180, 320]]
	},

}

class LastRequest(object):

	def __init__(self):
		self.players = {}
		self.lastrequest = False
		self.t = None
		self.ct = None
		self.lrwinner = None
		self.start1 = None
		self.start2 = None
		self.race_end = None
		self.deaglecoords = {}
		self.w1 = 0
		self.w2 = 0
		self.ws_startingpoint = []
		self.wsdone = []
		self.w3 = 0
		self.w4 = 0
		self.ct_weapons = {}

	def can_lr(self, userid, ip=True):
		if playerlib.getPlayer(userid).get('isdead'):
			es.tell(userid, '#multi', text('must be alive', {}, playerlib.getPlayer(userid).get('lang')))
			return

		if not es.getplayerteam(userid) == 2:
			es.tell(userid, '#multi', text('must be terrorist', {}, playerlib.getPlayer(userid).get('lang')))
			return

		if not len(playerlib.getPlayerList('#t,#alive')) <= int(sv('min_players_for_lr')):
			es.tell(userid, '#multi', text('too many ts', {}, playerlib.getPlayer(userid).get('lang')))
			return

		if self.lastrequest and ip:
			es.tell(userid, '#multi', text('lr in progress', {}, playerlib.getPlayer(userid).get('lang')))
			return
		return True

	def initiate_request(self, userid):
		if self.can_lr(userid):
			popuplib.send('Last Request', userid)

	def S4S(self):
		for userid in es.getUseridList():
			es.tell(userid, '#multi', text('s4s', {'t': es.getplayername(self.t), 'ct': es.getplayername(self.ct)}, playerlib.getPlayer(userid).get('lang')))

		playerlib.getPlayer(self.t).set('health', 100)
		playerlib.getPlayer(self.ct).set('health', 100)
		es.server.queuecmd('es_xgive %s weapon_deagle;es_xgive %s weapon_deagle'%(self.t, self.ct))
		self.beacon(self.t)
		self.beacon(self.ct)
		if int(sv('beacon_on_lr')):
			for userid in es.getUseridList():
				es.tell(userid, '#multi', text('s4s start', {}, playerlib.getPlayer(userid).get('lang')))

		self.lastrequest = 'S4S'
		if int(sv('hosties_teleport_to_designated_areas_for_lr')):
			m = str(sv('eventscripts_currentmap'))
			if m in map_points:
				if 's4s' in map_points[m]:
					x, y, z = map_points[m]['s4s'][0]
					x2, y2, z2 = map_points[m]['s4s'][1]
					for u in [self.t, self.ct]:
						es.tell(u, '#multi', text('prepare to teleport', {}, playerlib.getPlayer(u).get('lang')))
						for a in range(1, 4):
							gamethread.delayed(a, es.centertell(u, {1: 3, 2: 2, 3: 1}[a]))
					es.server.queuecmd('es_xsetpos %s %s %s %s'%(self.t, x, y, z))
					es.server.queuecmd('es_xsetpos %s %s %s %s'%(self.ct, x2, y2, z2))

	def GT(self):
		for userid in es.getUseridList():
			es.tell(userid, '#multi', text('gt', {'t': es.getplayername(self.t), 'ct': es.getplayername(self.ct)}, playerlib.getPlayer(userid).get('lang')))
			es.tell(userid, '#multi', text('gt rules', {}, playerlib.getPlayer(userid).get('lang')))

		self.beacon(self.t)
		self.beacon(self.ct)
		es.server.queuecmd('es_xgive %s weapon_deagle;es_xgive %s weapon_deagle'%(self.t, self.ct))
		self.lrwinner = self.t
		if int(sv('hosties_teleport_to_designated_areas_for_lr')):
			m = str(sv('eventscripts_currentmap'))
			if m in map_points:
				if 'gt' in map_points[m]:
					x, y, z = map_points[m]['gt'][0]
					x2, y2, z2 = map_points[m]['gt'][1]
					for u in [self.t, self.ct]:
						es.tell(u, '#multi', text('prepare to teleport', {}, playerlib.getPlayer(u).get('lang')))
						for a in range(1, 4):
							gamethread.delayed(a, es.centertell(u, {1: 3, 2: 2, 3: 1}[a]))
					gamethread.delayed(3, es.server.queuecmd, ('es_xsetpos %s %s %s %s'%(self.t, x, y, z)))
					gamethread.delayed(3, es.server.queuecmd, ('es_xsetpos %s %s %s %s'%(self.ct, x2, y2, z2)))

	def CF(self):
		for userid in es.getUseridList():
			lang = playerlib.getPlayer(userid).get('lang')
			es.tell(userid, '#multi', text('CF1', {'t': es.getplayername(self.t), 'ct': es.getplayername(self.ct)}, lang))
			es.tell(userid, '#multi', text('CF2', {}, lang))
			es.tell(userid, '#multi', text('CF3', {}, lang))

		self.beacon(self.t)
		self.beacon(self.ct)

	def KF(self):
		for userid in es.getUseridList():
			es.tell(userid, '#multi', text('KF', {'t': es.getplayername(self.t), 'ct': es.getplayername(self.ct)}, playerlib.getPlayer(userid).get('lang')))
			es.tell(userid, '#multi', text('KF2', {}, playerlib.getPlayer(userid).get('lang')))

		playerlib.getPlayer(self.t).set('health', 100)
		playerlib.getPlayer(self.ct).set('health', 100)
		for userid in [self.t, self.ct]:
			es.server.queuecmd('es_xgive %s player_weaponstrip'%userid)
			es.server.queuecmd('es_xfire %s player_weaponstrip strip'%userid)
			es.server.queuecmd('es_xgive %s weapon_knife'%userid)
			self.beacon(userid)
		es.server.queuecmd('es_xfire %s player_weaponstrip kill'%userid)
		self.save_ct_weapons()

	def save_ct_weapons(self):
		p = playerlib.getPlayer(self.ct)
		self.ct_weapons = {'primary': p.get('primary') if not p.get('primary') == '0' else None, 'secondary': p.get('secondary') if not p.get('secondary') == '0' else None}

	def WS(self):
		for userid in es.getUseridList():
			es.tell(userid, '#multi', text('WS', {'t': es.getplayername(self.t), 'ct': es.getplayername(self.ct)}, playerlib.getPlayer(userid).get('lang')))

		chosemenu = popuplib.easymenu('Choose WS', '_popup_choice', ws_select)
		chosemenu.settitle(text('Choose WS', {}, menu_lang))
		chosemenu.addoption('Choose Point', text('Choose Point', {}, menu_lang))
		popuplib.send('Choose WS', self.t)
		es.tell(self.t, '#multi', text('ws start', {}, playerlib.getPlayer(self.t).get('lang')))
		self.beacon(self.t)
		self.beacon(self.ct)

	def WS_start(self):
		for userid in es.getUseridList():
			lang = playerlib.getPlayer(userid).get('lang')
			es.tell(userid, '#multi', text('ws message 1', {}, lang))
			es.tell(userid, '#multi', text('ws message 2', {}, lang))

		for u in [self.t, self.ct]:
			x, y, z = self.ws_startingpoint
			es.server.queuecmd('es_xsetpos %s %s %s %s'%(u, x, y, z))
			es.setplayerprop(u, 'CBaseEntity.m_CollisionGroup', 2)
			gamethread.delayed(15, es.setplayerprop, (u, 'CBaseEntity.m_CollisionGroup', 0))
			playerlib.getPlayer(u).set('freeze', 1)
			gamethread.delayed(3, playerlib.getPlayer(u).set, ('noclip', 0))
			es.server.queuecmd('es_xgive %s player_weaponstrip'%u)
			es.server.queuecmd('es_xfire %s player_weaponstrip strip'%u)
			gamethread.delayed(3, es.server.queuecmd, 'es_xgive %s weapon_deagle;es_xgive %s weapon_knife'%(u, u))
			playerlib.getPlayer(u).set('health', 100)
		es.server.queuecmd('es_fire %s player_weaponstrip kill'%u)
		for a in [0, 1, 2, 3]:
			gamethread.delayed(a, es.centermsg, {0: 3, 1: 2, 2: 1, 3: 'GO!'}[a])
		gamethread.delayed(3, self.ws_loop)
		gamethread.delayed(3.1, playerlib.getPlayer(self.ct).set, ('noclip', 0))

	def ws_loop(self):
		if self.lastrequest == 'WS':
			gamethread.delayedname(0.1, 'ws loop', self.ws_loop)
			x, y, z = self.ws_startingpoint
			for u in [self.t, self.ct]:
				x3, y3, z3 = self.w1 if u == self.t else self.w2
				if not u in self.wsdone:
					x2, y2, z2 = es.getplayerlocation(u)
					if math.sqrt(math.pow(x - x2, 2) + math.pow(y - y2, 2)) >= 500:
						self.wsdone.append(u)
						for userid in es.getUseridList():
							es.tell(userid, '#multi', text('paces taken', {'player': es.getplayername(u)}, playerlib.getPlayer(userid).get('lang')))
					es.server.queuecmd('es_xsetang %s %s %s %s'%(u, x3, y3, z3))
	def Race(self):
		tokens = {'t': es.getplayername(self.t), 'ct': es.getplayername(self.ct)}
		for userid in es.getUseridList():
			lang = playerlib.getPlayer(userid).get('lang')
			es.tell(userid, '#multi', text('race 1', tokens, lang))
			es.tell(userid, '#multi', text('race 2', tokens, lang))

		self.beacon(self.t)
		self.beacon(self.ct)
		popuplib.send('Chose Spawn Point 1', self.t)

	def race_effects(self):
		if self.lastrequest == 'Race':
			gamethread.delayedname(0.5, 'effect_loop', self.race_effects)
			if self.start1:
				effectlib.drawCircle(self.start1, 25, seconds=0.5, red=0, green=0, blue=255)
			if self.start2:
				effectlib.drawCircle(self.start2, 25, seconds=0.5, red=0, green=0, blue=255)
			if self.race_end:
				effectlib.drawCircle(self.race_end, 50, seconds=0.5, red=0, green=0, blue=255)
		else:
			self.start1 = self.start2 = self.race_end = None

	def start_race(self):
		for userid in es.getUseridList():
			es.tell(userid, '#multi', text('race start', {}, playerlib.getPlayer(userid).get('lang')))

		messages = {0: '3', 1: '2', 2: '1', 3: 'GO!'}
		b = [self.start1, self.start2]
		l1 = random.choice(b)
		b.remove(l1)
		l2 = b[0]
		es.server.queuecmd('es_xsetpos %s %s %s %s'%(self.t, l1[0], l1[1], l1[2]))
		es.server.queuecmd('es_xsetpos %s %s %s %s'%(self.ct, l2[0], l2[1], l2[2]))
		playerlib.getPlayer(self.t).set('freeze', 1)
		playerlib.getPlayer(self.ct).set('freeze', 1)
		gamethread.delayedname(3, 'unfreeze', playerlib.getPlayer(self.t).set, ('noclip', 0))
		gamethread.delayedname(3, 'unfreeze', playerlib.getPlayer(self.ct).set, ('noclip', 0))
		for a in range(4):
			gamethread.delayedname(a, 'racemessage', es.centermsg, messages[a])
		gamethread.delayed(3, self.race_check_won_loop)

	def race_check_won_loop(self):
		if self.lastrequest == 'Race':
			gamethread.delayedname(0.05, 'check_race_won', self.race_check_won_loop)
			x, y, z = self.race_end
			for a in [self.t, self.ct]:
				x2, y2, z2 = es.getplayerlocation(a)
				x3, y3, z3 = x - x2, y - y2, z - z2
				if math.sqrt(math.pow(z3, 2) + math.pow(y3, 2) + math.pow(z3,2)) <= 3.5:
					for userid in es.getUseridList():
						es.tell(userid, '#multi', text('won race', {'player': es.getplayername(a)}, playerlib.getPlayer(userid).get('lang')))

					self.lrwinner = a
					self.lastrequest = False
					break

	def check_chicken_won(self, userid):
		if self.lastrequest == 'CF':
			if userid in [self.t, self.ct]:
				if playerlib.getPlayer(self.t).get('distance', [self.ct, 'xy']) <= 40 and 180 >= playerlib.getPlayer(self.t).get('distance', [self.ct, 'z']) >= 60:
					for userid in es.getUseridList():
						es.tell(userid, '#multi', text('lost chicken fight', {'player': es.getplayername(self.ct)}, playerlib.getPlayer(userid).get('lang')))

					for userid2 in es.getUseridList():
						es.tell(userid2, '#multi', text('lost chicken fight', {'player': es.getplayername(self.ct)}, playerlib.getPlayer(userid2).get('lang')))

					self.lrwinner = self.ct
					self.lastrequest = False

				elif playerlib.getPlayer(self.t).get('distance', [self.ct, 'xy']) <= 40 and 180 >= playerlib.getPlayer(self.ct).get('distance', [self.t, 'z']) >= 60:
					for userid in es.getUseridList():
						es.tell(userid, '#multi', text('lost chicken fight', {'player': es.getplayername(self.ct)}, playerlib.getPlayer(userid).get('lang')))

					self.lastrequest = False
					self.lrwinner = self.t

				if not self.lastrequest:
					gamethread.cancelDelayed('beacon_%s'%self.t)
					gamethread.cancelDelayed('beacon_%s'%self.ct)

	def check_lr_won(self, userid, attacker, weapon):
		if self.lastrequest:
			if self.lastrequest == 'S4S':
				if userid in [self.t, self.ct] or attacker in [self.t, self.ct]:
					if not userid in [self.t, self.ct] or not attacker in [self.t, self.ct]:
						if userid == self.t:
							if not userid in Rb.rebels:
								for userid2 in es.getUseridList():
									es.tell(userid2, '#multi', text('killed by ct', {'player': es.getplayername(userid)}, playerlib.getPlayer(userid2).get('lang')))

								playerlib.getPlayer(attacker).set('health', 25)
								self.lastrequest = False
								return
					'''
					if es.getplayerteam(attacker) == 2:
						for userid2 in es.getUseridList():
							es.tell(userid2, '#multi', text('rebel', {'player': es.getplayername(attacker)}, playerlib.getPlayer(userid2).get('lang')))

						Rb.rebels.append(attacker)
						self.lastrequest = False
						return
					'''

					for userid2 in es.getUseridList():
						es.tell(userid2, '#multi', text('won s4s', {'player': es.getplayername(attacker)}, playerlib.getPlayer(userid).get('lang')))

					self.lrwinner = attacker
					self.lastrequest = False
					gamethread.cancelDelayed('beacon_%s'%self.t)
					gamethread.cancelDelayed('beacon_%s'%self.ct)
			elif self.lastrequest == 'KF':
				if weapon == 'knife':
					if attacker == self.t:
						if userid == self.ct:
							for userid2 in es.getUseridList():
								es.tell(userid2, '#multi', text('won kf', {'player': es.getplayername(attacker)}, playerlib.getPlayer(userid2).get('lang')))

							self.lastrequest = False
							self.lrwinner = attacker
							return
						for userid2 in es.getUseridList():
							es.tell(userid2, '#multi', text('rebel', {'player': es.getplayername(attacker)}, playerlib.getPlayer(userid2).get('lang')))

						self.lastrequest = False
						Rb.rebels.append(attacker)
					elif attacker == self.ct:
						if userid == self.t:
							for userid2 in es.getUseridList():
								es.tell(userid2, '#multi', text('won kf', {'player': es.getplayername(attacker)}, playerlib.getPlayer(userid2).get('lang')))
							self.lastrequest = False
				else:
					if attacker == self.t:
						for userid2 in es.getUseridList():
							es.tell(userid2, '#multi', text('rebel', {'player': es.getplayername(attacker)}, playerlib.getPlayer(userid2).get('lang')))

					elif attacker == self.ct:
						for userid2 in es.getUseridList():
							es.tell(userid2, '#multi', text('gun used', {'player': es.getplayername(self.ct)}, playerlib.getPlayer(userid2).get('lang')))

			if not self.lastrequest:
				for u in [self.t, self.ct]:
					if u:
						if not playerlib.getPlayer(u).get('isdead'):
							playerlib.getPlayer(u).set('color', [255, 255, 255, 255])

	def beacon(self, userid):
		if not playerlib.getPlayer(userid).get('isdead'):
			if self.lastrequest:
				if int(sv('beacon_on_lr')):
					gamethread.cancelDelayed('beacon_%s'%userid)
					gamethread.delayedname(1, 'beacon_%s'%userid, self.beacon, userid)
					x, y, z = es.getplayerlocation(userid)
					es.server.queuecmd('est_effect 10 #a 0 "sprites/lgtning.vmt" %s %s %s 20 300 0.2 20 10 0 255 0 0 255 30'%(x, y, z))
					es.server.queuecmd('est_effect 10 #a 0.1 "sprites/lgtning.vmt" %s %s %s 20 300 0.3 15 10 0 255 150 150 255 30'%(x, y, z))
					es.emitsound('player', userid, 'buttons/blip2.wav', 0.8, 0.6)

				if int(sv('beacon_on_lr')):
					es.setplayerprop(userid, 'CBaseEntity.m_CollisionGroup', 5)
			else:
				if int(sv('beacon_on_lr')):
					for u in [self.t, self.ct]:
						if not playerlib.getPlayer(u).get('isdead'):
							playerlib.getPlayer(u).set('color', [255, 255, 255, 255])

				if int(sv('hosties_enable_noblock')):
					es.setplayerprop(userid, 'CBaseEntity.m_CollisionGroup', 2)


	def deagle_loop(self, userid, index):
		if self.lastrequest:
			if userid in [self.t, self.ct]:
				gamethread.delayedname(0.5, 'deagle_loop', self.deagle_loop, (userid, index))
				if not self.deaglecoords:
					self.deaglecoords = {self.t: None, self.ct: None}
				if es.getindexprop(index, 'CDEagle.baseclass.baseclass.m_iState') == 0:
					if not es.getindexprop(index, 'CDEagle.baseclass.baseclass.baseclass.baseclass.m_vecOrigin') == '0,0,0':
						x, y, z = map(float, es.getindexprop(index, 'CDEagle.baseclass.baseclass.baseclass.baseclass.m_vecOrigin').split(','))
						if not (x, y, z) == self.deaglecoords[userid]:
							self.deaglecoords[userid] = x, y, z
				if self.deaglecoords[userid]:
					x, y, z = self.deaglecoords[userid]
					effectlib.drawLine([x, y, z], [x, y, z + 30], seconds=0.5, red=0, green=0)
		else:
			self.deaglecoords.clear()

LR = LastRequest()
lrfuncs = {
	'Shot For Shot': LR.S4S,
	'Gun Toss': LR.GT,
	'Chicken Fight': LR.CF,
	'Knife Fight': LR.KF,
	'Race': LR.Race,
	'Western Shootout': LR.WS,
}

class Rebel(object):

	def __init__(self):
		self.rebels = []
		self.ik = {}
		self.iks = {}
		self.rebelchange = {}
		self.kps = {}
		self.on_heads = {}
		self.pfk = {}
		self.trounds = {}

	def player_death(self, userid, attacker, weapon):
		if not userid == attacker:
			tokens = {'t': es.getplayername(attacker if es.getplayerteam(attacker) == 2 else userid), 'ct': es.getplayername(attacker if es.getplayerteam(attacker) == 3 else userid), 'player': es.getplayername(attacker)}
			if userid in [LR.t, LR.ct] or attacker in [LR.t, LR.ct]:
				LR.lastrequest = False
			if es.getplayerteam(attacker) == 2:
				if attacker in self.on_heads:
					if self.on_heads[attacker] == userid:
						del self.on_heads[attacker]
						if weapon == 'knife':
							for userid2 in es.getUseridList():
								lang = playerlib.getPlayer(userid2).get('lang')
								es.tell(userid2, '#multi', text('killed for head1', tokens, lang))
								es.tell(userid2, '#multi', text('killed for head2', tokens, lang))
							return

				if not attacker == LR.lrwinner:
					if not attacker in self.rebels:
						if int(sv('announce_turn_into_rebel')):
							for userid2 in es.getUseridList():
								es.tell(userid2, '#multi', text('rebel', tokens, playerlib.getPlayer(userid2).get('lang')))
						self.rebels.append(attacker)
				else:
					LR.lrwinner = None
					return

			self.check_rebel(userid)
			if userid in self.rebels:
				if int(sv('announce_rebel_killed')):
					for userid2 in es.getUseridList():
						es.tell(userid2, '#multi', text('killed a rebel', tokens, playerlib.getPlayer(userid2).get('lang')))

			if not userid in self.rebels:
				if es.getplayerteam(attacker) == 3:
					if attacker == LR.lrwinner:
						LR.lrwinner = None
						return
					self.ik[attacker] = self.ik[attacker] + 1 if attacker in self.ik else 1

					if self.ik[attacker] in self.pfk:
						self.punish(attacker, self.pfk[self.ik[attacker]])
					self.kps[attacker] = self.kps[attacker] + 1 if attacker in self.kps else 1
					gamethread.delayed(1.5, self.make_0, attacker)

					if self.kps[attacker] >= int(sv('max_innocent_kills_per_3_seconds')):
						self.punish(attacker, str(sv('too_high_kps_punishment')))
					self.iks[attacker][userid] = self.iks[attacker][userid] + 1 if userid in self.iks[attacker] else 1

					if self.iks[attacker][userid] in tmik:
						pmenu = popuplib.easymenu('Punishment Menu', '_popup_choice', pmenu_select)
						pmenu.settitle(text('Punishment Menu', {}, menu_lang))
						for option in tmik[self.iks[attacker][userid]].split(','):
							pmenu.addoption([attacker, option], option)
						popuplib.send('Punishment Menu', userid)

			elif es.getplayerteam(attacker) == 3:
				self.iks[attacker][userid] = 0
			gamethread.delayed(0, self.set_rebel_color)

	def set_rebel_color(self):
		r, g, b, a = str(sv('hosties_rebel_color')).split(',')
		for userid in self.rebels:
			playerlib.getPlayer(userid).set('color', [r, g, b, a])

	def check_dead(self, userid):
		if not playerlib.getPlayer(userid).get('isdead'):
			es.server.queuecmd('damage %s 32 2'%userid)

	def punish(self, userid, o):
		o = o.replace('\r', '')
		if o == 'slay':
			playerlib.getPlayer(userid).set('health', 1)
			es.server.queuecmd('es_xfire %s !self ignite')
			gamethread.delayed(0.1, self.check_dead, userid)

		elif o == 'kick':
			es.server.queuecmd('kickid %s Don\'t line up and kill hosties!'%userid)
			tokens = {'player': es.getplayername(userid), 'steamid': es.getplayersteamid(userid), 'ip': playerlib.getPlayer(userid).get('ip')}
			for userid2 in es.getUseridList():
				es.tell(userid2, '#multi', text('line up kick', tokens, playerlib.getPlayer(userid2).get('lang')))
			return

		elif o.startswith('takehp'):
			playerlib.getPlayer(userid).set('health', max(playerlib.getPlayer(userid).get('health') - int(o[6:]), 1))

		elif o == 'stripweapons':
			es.server.queuecmd('es_xgive %s player_weaponstrip'%userid)
			es.server.queuecmd('es_fire %s player_weaponstrip strip'%userid)
			es.server.queuecmd('es_fire %s player_weaponstrip kill'%userid)

		elif o.startswith('maket'):
			self.trounds[es.getplayersteamid(userid)] = int(o[5:])
			es.server.queuecmd('est_team %s 2'%userid)
			es.tell(userid, '#multi', text('rounds as t', {'rounds': o[5:]}, playerlib.getPlayer(userid).get('lang')))

		elif o.startswith('ban'):
			es.server.queuecmd('banid %s %s'%(o[3:], es.getplayersteamid(userid)))
			es.server.queuecmd('writeid')
			es.server.queuecmd('kickid %s You have been banned for %s minutes for lining up and killing hosties!'%(userid, o[3:]))
		es.tell(userid, '#multi', text('dont kill innocent', {}, playerlib.getPlayer(userid).get('lang')))

	def make_0(self, userid):
		self.kps[userid] = 0

	def check_rebel(self, userid):
		if es.getplayerteam(userid) == 2:
			if not playerlib.getPlayer(userid).get('primary') == '0':
				self.rebels.append(userid)
			elif not playerlib.getPlayer(userid).get('primary') == '0':
				self.rebels.append(userid)

	def check_on_head(self, userid):
		if int(sv('allow_to_kill_for_jumping_on_head')):
			if es.getplayerteam(userid) == 3:
				for userid2 in playerlib.getUseridList('#t,#alive'):
					if playerlib.getPlayer(userid).get('distance', [userid2, 'xy']) <= 40 and 180 >= playerlib.getPlayer(userid).get('distance', [userid2, 'z']) >= 60:
						self.on_heads[userid2] = userid
						break

	def add_punishment(self, args):
		if not args[0].isdigit():
			es.dbgmsg(0, 'Invalid amount of kills for hosties_addpunishment!')
			return

		if int(args[0]) in self.pfk:
			es.dbgmsg(0, 'Already a punishment for %s kills!'%args[0])
			return

		self.pfk[int(args[0])] = args[1]

Rb = Rebel()

class Control(object):

	def __init__(self):
		self.controller = None
		self.pd = {}
		self.say_times = {'rotate': 2, 'simon_says': 1, 'jump': 1, 'crouch': 1}
		self.is_order = False
		self.simon_says = False

	def take_control(self, userid):
		if self.controller:
			es.tell(userid, '#multi', text('already controller', {}, playerlib.getPlayer(userid).get('lang')))
			return

		if not es.getplayerteam(userid) == 3:
			es.tell(userid, '#multi', text('must be ct', {}, playerlib.getPlayer(userid).get('lang')))
			return

		if playerlib.getPlayer(userid).get('isdead'):
			es.tell(userid, '#multi', text('must be alive', {}, playerlib.getPlayer(userid).get('lang')))
			return

		if LR.lastrequest:
			es.tell(userid, '#multi', text('no control during lr', {}, playerlib.getPlayer(userid).get('lang')))
			return

		if not len(filter(lambda x: x not in Rb.rebels, playerlib.getUseridList('#t,#alive'))):
			es.tell(userid, '#multi', text('no non rebellers', {}, playerlib.getPlayer(userid).get('lang')))
			return

		self.controller = userid
		playerlib.getPlayer(userid).set('color', str(sv('hosties_controller_color')).split(','))
		for userid2 in es.getUseridList():
			es.tell(userid, '#multi', text('now controller', {'player': es.getplayername(userid)}, playerlib.getPlayer(userid2).get('lang')))

	def stop_control(self, userid):
		if not self.controller == userid:
			es.tell(userid, '#multi', text('not controller', {}, playerlib.getPlayer(userid).get('lang')))
			return

		self.stop_controlling()
		for userid2 in es.getUseridList():
			es.tell(userid2, '#multi', text('no longer controller', {'player': es.getplayername(userid)}, playerlib.getPlayer(userid2).get('lang')))

	def issue_order(self, userid, order, simon_says):
		if not len(filter(lambda x: x not in Rb.rebels, playerlib.getUseridList('#t,#alive'))):
			es.tell(userid, '#multi', text('no non rebellers', {}, playerlib.getPlayer(userid).get('lang')))
			return

		if self.is_order:
			es.tell(userid, '#multi', text('order in progress', {}, playerlib.getPlayer(userid).get('lang')))
			return

		if not userid == self.controller:
			es.tell(userid, '#multi', text('not controller', {}, playerlib.getPlayer(userid).get('lang')))
			return

		if playerlib.getPlayer(userid).get('isdead'):
			es.tell(userid, '#multi', text('must be alive', {}, playerlib.getPlayer(userid).get('lang')))
			return

		sound = ''
		if simon_says:
			sound += 'simon_says,'
		sound += {'Rotate 180 Degrees': 'rotate', 'Jump': 'jump', 'Crouch': 'crouch', 'Crouch Jump': 'crouch,jump'}[order]
		for userid2 in es.getUseridList():
			es.centertell(userid2, sound.replace(',', ' '))
			usermsg.hudhint(userid, sound.replace(',', ' '))
			es.tell(userid, '#multi', '#lightgreen[Hosties]: #default%s'%sound.replace(',', ' '))
			delay = -self.say_times[sound.split(',')[0]]
			for s in sound.split(','):
				delay += self.say_times[s]
				gamethread.delayedname(delay, 'play sound', es.cexec, (userid2, 'play hosties/%s.mp3'%s))
			if es.getplayerteam(userid2) == 2 and not playerlib.getPlayer(userid2).get('isdead'):
				self.pd[userid2] = {'crouched': False, 'spun': False, 'spin_angles': playerlib.getPlayer(userid2).get('viewangle'), 'jumped': False}

		self.simon_says = simon_says
		if simon_says:
			if order == 'Rotate 180 Degrees':
				self.spin_check_loop(int(sv('hosties_control_command_time')))
			elif order == 'Crouch':
				self.crouch_check_loop(int(sv('hosties_control_command_time')))

		self.is_order = order
		gamethread.delayedname(int(sv('hosties_control_command_time')), 'control time up', self.end_order)
		es.msg('#multi', '#lightgreen[Hosties]: #defaultAll terrorists have #lightgreen%s#default seconds to #lightgreen%s!'%(int(sv('hosties_control_command_time')), order))

	def end_order(self):
		gamethread.cancelDelayed('control time up')
		message = 'Order has been finished, everyone that did not finish task has been turned into a rebel!' if self.simon_says else 'Order is finished'
		es.msg('#multi', '#lightgreen[Hosties]: #default' + message)

		if self.simon_says:
			for userid in self.pd:
				playerlib.getPlayer(userid).set('color', [255,255,255,255])
				if not self.pd[userid][{'Rotate 180 Degrees': 'spun', 'Jump': 'jumped', 'Crouch': 'crouched', 'Crouch Jump': 'jumped'}[self.is_order]]:
					es.tell(userid, '#multi', text('now rebel', {}, playerlib.getPlayer(userid).get('lang')), 'for not completing the orders')
					Rb.rebels.append(userid)
					if not str(sv('hosties_rebel_color')) == '0':
						playerlib.getPlayer(userid).set('color', str(sv('hosties_rebel_color')).split(','))

		self.pd.clear()
		self.simon_says = False
		self.is_order = False

	def spin_check_loop(self, time_left):
		time_left -= 0.1
		if time_left >= 0:
			gamethread.delayedname(0.1, 'spin check', self.spin_check_loop, time_left)
			for userid in playerlib.getUseridList('#t,#alive'):
				if userid in self.pd:
					if not userid in Rb.rebels and not self.pd[userid]['spun']:
						x, y, z = playerlib.getPlayer(userid).get('viewangle')
						x2, y2, z2 = self.pd[userid]['spin_angles']
						y = y if y >= 0 else -y + 180
						y2 = y2 if y2 >= 0 else -y + 180
						if 160 <= abs(y - y2) >= 200:
							es.tell(userid, '#multi', text('task completed', {}, playerlib.getPlayer(userid).get('lang')))
							playerlib.getPlayer(userid).set('color', str(sv('hosties_simon_says_completed_color')).split(','))
							self.pd[userid]['spun'] = True
							self.check_over()

	def crouch_check_loop(self, time_left):
		time_left -= 0.1
		if time_left > 0:
			for userid in playerlib.getUseridList('#t,#alive'):
				if not userid in Rb.rebels and not self.pd[userid]['crouched']:
					if es.getplayerprop(userid, 'CBasePlayer.localdata.m_Local.m_bDucked') % 2:
						playerlib.getPlayer(userid).set('color', str(sv('hosties_simon_says_completed_color')).split(','))
						self.pd[userid]['crouched'] = True
						self.check_over()
			gamethread.delayedname(0.1, 'crouch check', self.crouch_check_loop, time_left)

	def stop_controlling(self):
		if es.exists('userid', self.controller):
			if not playerlib.getPlayer(self.controller).get('isdead'):
				playerlib.getPlayer(self.controller).set('color', [255, 255, 255, 255])
		self.controller = None
		self.is_order = False
		for delay in ['play sound', 'spin check', 'crouch check']:
			gamethread.cancelDelayed(delay)

	def player_jump(self, userid):
		if self.is_order:
			if 'Jump' in self.is_order:
				if es.getplayerteam(userid) == 2:
					if not self.pd[userid]['jumped']:
						if 'Crouch' in self.is_order and not es.getplayerprop(userid, 'CBasePlayer.localdata.m_Local.m_bDucked') % 2:
							es.tell(userid, '#multi', text('must be crouch jumping', {}, playerlib.getPlayer(userid).get('lang')))
							return
						self.pd[userid]['jumped'] = True
						playerlib.getPlayer(userid).set('color', str(sv('hosties_simon_says_completed_color')).split(','))
						self.check_over()

	def check_over(self):
		if not len(filter(lambda x: not self.pd[x][{'Rotate 180 Degrees': 'spun', 'Jump': 'jumped', 'Crouch': 'crouched', 'Crouch Jump': 'jumped'}[self.is_order]], self.pd.keys())):
			self.end_order()

CTRL = Control()

### Loads ###

def load():
	global text, menu_lang
	for option in sv_options:
		es.ServerVar(option).set(sv_options[option])

	if not es.exists('command', 'hosties_rule'):
		es.regcmd('hosties_rule', 'hosties/hosties_rule')

	if not es.exists('command', 'hosties_addpunishment'):
		es.regcmd('hosties_addpunishment', 'hosties/hosties_addpun')

	if not es.exists('command', 'hosties_add_menu_punishment'):
		es.regcmd('hosties_add_menu_punishment', 'hosties/add_menu_punishment')

	if os.path.isfile(es.getAddonPath('hosties') + '/hosties.cfg'):
		es.server.cmd('es_xmexec ../addons/eventscripts/hosties/hosties.cfg')
	menu_lang = str(sv('hosties_menu_lang'))

	if not os.path.isfile(es.getAddonPath('hosties') + '/hosties.ini'):
		es.bgmsg(0, 'Hosties Error: No hosties.ini under cstrike/addons/eventscripts/hosties !')
		return
	text = langlib.Strings(es.getAddonPath('hosties') + '/hosties.ini')

	lrmenu = popuplib.easymenu('Last Request', '_popup_choice', lrmenu_select)
	lrmenu.settitle(text('Last Request', {}, menu_lang))

	sp1 = popuplib.easymenu('Chose Spawn Point 1', '_popup_choice', sp1_select)
	sp1.settitle(text('Chose Spawn Point 1', {}, menu_lang))
	sp1.addoption(text('Add Starting Point', {}, menu_lang), 'Add Starting Point') 

	sp2 = popuplib.easymenu('Chose Spawn Point 2', '_popup_choice', sp2_select)
	sp2.settitle(text('Chose Spawn 2', {}, menu_lang))
	sp2.addoption(text('Add Starting Point', {}, menu_lang), 'Add Starting Point')

	sp3 = popuplib.easymenu('Chose End Point', '_popup_choice', race_end_select)
	sp3.settitle(text('Chose End Point', {}, menu_lang))
	sp3.addoption(text('Chose Ending Point', {}, menu_lang), 'Chose Ending Point')

	control_menu = popuplib.easymenu('Control', '_popup_choice', control_select)
	control_menu.settitle(text('Chose End Point', {}, menu_lang))

	for option in ['Become Controller', 'Stop Controlling', 'Issue Command']:
		control_menu.addoption(option, text(option, {}, menu_lang))

	issue_menu = popuplib.easymenu('Issue Command', '_popup_choice', issue_select)
	issue_menu.settitle(text('Issue Command', {}, menu_lang))
	for option in ['Rotate 180 Degrees', 'Jump', 'Crouch', 'Crouch Jump']:
		issue_menu.addoption(option, text(option, {}, menu_lang))

	gamethread.delayed(0.1, set_rules)
	es.addons.registerClientCommandFilter(_restrict_weapons)

	hosties_menu = popuplib.easymenu('Hosties', '_popup_choice', hosties_select)
	for option in ['Rules', 'Commands']:
		hosties_menu.addoption(option, text(option.lower(), {}, menu_lang))

	command_menu = popuplib.easymenu('Commands', '_popup_choice', command_select)
	command_menu.settitle(text('commands', {}, menu_lang))
	for option in ['!lr', '!rules', '!commands', '!hosties', '!checkplayers', '!setpoints', '!control', '!wspoint']:
		command_menu.addoption(option, '!' + text(option[1:], {}, menu_lang).lower())

	for option in ['Shot For Shot', 'Gun Toss', 'Chicken Fight', 'Knife Fight', 'Race', 'Western Shootout']:
		if {'Shot For Shot': 'S4S', 'Gun Toss': 'GT', 'Chicken Fight': 'CF', 'Knife Fight': 'KF', 'Race': 'Race', 'Western Shootout': 'WS'}[option] in str(sv('hosties_enabled_lrs')):
			lrmenu.addoption(option, text(option, {}, menu_lang))

	for sound in ['crouch.mp3', 'rotate.mp3', 'jump.mp3', 'simon_says.mp3']:
		es.stringtable('downloadables', 'sound/hosties/' + sound)

	for userid in es.getUseridList():
		Rb.iks[userid] = {}

	if int(sv('hosties_silent_commands')):
		for command in ['lr', 'rules', 'commands', 'hosties', 'checkplayers', 'setpoints', 'checkguns', 'control', 'wspoint']:
			if '!' + command in str(sv('hosties_commands')):
				for command2 in [command, '!' + command]:
					if not es.exists('saycommand', command2):
						es.regsaycmd(command2, 'hosties/say_command')
					if not es.exists('clientcommand', command2):
						es.regsaycmd(command2, 'hosties/say_command')

	es.flags('remove', 'cheat', 'endround')

def unload():
	es.addons.unregisterClientCommandFilter(_restrict_weapons)
	for delay in ['effect_loop', 'racemessage', 'unfreeze', 'check_race_won', 'deagle_loop', 'ws loop']:
		gamethread.cancelDelayed(delay)

### Commands ###

def lastrequest():
	LR.initiate_request(es.getuserid())

### Events ###

def player_team(ev):
	if ev['es_steamid'] in Rb.trounds:
		if es.getplayerteam(ev['userid']) == 3:
			es.server.queuecmd('est_team %s 2'%ev['userid'])
			es.server.queuecmd('es_xsetpos %s '%ev['userid'] + '%s %s %s'%return_random_t_spawn())
			es.tell(ev['userid'], '#multi', text('rounds as t', {'rounds': Rb.trounds[es.getplayersteamid(ev['userid'])]}, playerlib.getPlayer(userid).get('lang')))

def say_command():
	player_say({'userid': str(es.getcmduserid()), 'text': str('!' + es.getargv(0).replace('!', '')).replace('"', '')})

def player_say(ev):
	text = ev['text'].lower()
	if text in ['!lr', '!rules', '!checkplayers', '!commands', '!hosties', '!control', '!checkguns', '!wspoint', '!setpoints']:
		userid = int(ev['userid'])

		if not text in str(sv('hosties_commands')):
			es.tell(userid, '#multi', text('disabled command', {}, playerlib.getPlayer(userid).get('lang')))
			return

		if text == '!lr':
			LR.initiate_request(userid)

		elif text == '!rules':
			popuplib.send('Rules', userid)

		elif text == '!checkplayers':
			playermenu = popuplib.easymenu('Check Players', '_popup_choice', checkplayer_select)
			for userid2 in playerlib.getUseridList('#t,#alive'):
				playermenu.addoption(userid, ('[Rebel]' if userid2 in Rb.rebels else '[Non Rebel]') + ' %s'%es.getplayername(userid2))
			popuplib.send('Check Players', userid)

		elif text == '!commands':
			popuplib.send('Commands', userid)

		elif text == '!hosties':
			popuplib.send('Hosties', userid)

		elif text == '!setpoints':
			if not userid == LR.t:
				es.tell(userid, text('not in race', {}, playerlib.getPlayer(userid).get('lang')))
				return

			if not LR.start1:
				popuplib.send('Chose Spawn Point 1', userid)

			elif not LR.start2:
				popuplib.send('Chose Spawn 2', userid)

			elif not LR.race_end:
				popuplib.send('Chose End Point', userid)

			else:
				es.tell(userid, '#multi', text('chosen all spawns', {}, playerlib.getPlayer(userid).get('lang')))

		elif text == '!control':
			if int(sv('hosties_enable_control')):
				if not es.getplayerteam(userid) == 3:
					es.tell(userid, '#multi', text('must be ct', {}, playerlib.getPlayer(userid).get('lang')))
					return
				popuplib.send('Control', userid)

		elif text == '!checkguns':
			gunmenu = popuplib.easymenu('Player Guns', '_popup_choice', gunmenu_select)
			for p in playerlib.getPlayerList('#t,#alive'):
				gunmenu.addoption(int(p), '%s [P: %s, S: %s]'%(p.get('name'), 'No' if p.get('primary') == '0' else 'Yes', 'No' if p.get('secondary') == '0' else 'Yes'))
			popuplib.send('Player Guns', ev['userid'])

		elif text == '!wspoint':
				if not (userid == LR.t and LR.lastrequest == 'WS'):
					es.tell(userid, '#multi', text('not in ws', {}, playerlib.getPlayer(userid).get('lang')))
					return

				if LR.w1:
					es.tell(userid, '#multi', text('chosen all spawns', {}, playerlib.getPlayer(userid).get('lang')))
					return

				popuplib.send('Choose WS', userid)

def player_death(ev):
	userid = int(ev['userid'])
	attacker = int(ev['attacker'])
	LR.check_lr_won(userid, attacker, ev['weapon'])
	Rb.player_death(userid, attacker, ev['weapon'])

	if len(playerlib.getPlayerList('#t,#alive')) == int(sv('min_players_for_lr')):
		if int(sv('hosties_announce_lr_available')):
			for userid2 in es.getUseridList():
				es.tell(userid2, '#multi', text('lr available', {}, playerlib.getPlayer(userid2).get('lang')))

	if userid == CTRL.controller:
		CTRL.stop_control(userid)

def player_activate(ev):
	if int(sv('hosties_show_rules_on_join')):
		popuplib.send('Hosties', ev['userid'])
	Rb.iks[int(ev['userid'])] = {}

def player_jump(ev):
	if int(sv('hosties_enable_chicken_fight_won')):
		gamethread.delayed(0.3, LR.check_chicken_won, int(ev['userid']))
	gamethread.delayed(0.3, Rb.check_on_head, int(ev['userid']))
	CTRL.player_jump(int(ev['userid']))

def round_start(ev):
	global rounds
	Rb.rebels = []
	stop_lrs()
	rounds += 1

	if int(sv('hosties_end_round_at_round_end_time')):
		gamethread.delayedname(float(sv('mp_roundtime')) * 60, 'end_round', es.server.queuecmd, 'endround')

	if int(sv('hosties_round_swap_teams')):
		if rounds >= int(sv('hosties_round_swap_teams')):
			t_uil = playerlib.getUseridList('#t')
			ct_uil = playerlib.getUseridList('#ct')
			for userid in ct_uil:
				es.server.queuecmd('es_xsetpos %s %s'%(userid, ' '.join(return_random_t_spawn())))
				es.server.queuecmd('est_team %s 2'%userid)
			gamethread.delayed(0, gamethread.delayed, (0, teleport_ts, t_uil))
	CTRL.stop_controlling()

def teleport_ts(uil):
	for userid in uil:
		es.server.queuecmd('est_team %s 3'%userid)
		es.server.queuecmd('es_xsetpos %s %s'%(userid, ' '.join(return_random_t_spawn(True))))

def round_end(ev):
	stop_lrs()
	gamethread.cancelDelayed('end_round')
	Rb.ik.clear()
	Rb.on_heads.clear()

	for userid in es.getUseridList():
		gamethread.cancelDelayed('freeze %s'%userid)
		if not es.getplayersteamid(userid) == 'BOT':
			if popuplib.isqueued('Punishment Menu', userid):
				popuplib.close('Punishment Menu', userid)

	for steamid in Rb.trounds:
		Rb.trounds[steamid] -= 1
		if Rb.trounds[steamid] <= 0:
			del Rb.trounds[steamid]
			if es.getuserid(steamid):
				es.tell(es.getuserid(steamid), '#multi', text('can go t', {}, playerlib.getPlayer(es.getuserid(steamid)).get('lang')))
	CTRL.stop_controlling()

def player_disconnect(ev):
	u = int(ev['userid'])
	for td in [Rb.kps, Rb.ik, CTRL.pd]:
		if u in td:
			del td[u]

	if u == CTRL.controller:
		CTRL.stop_controlling()
		for userid in es.getUseridList():
			es.tell(userid, '#multi', text('no longer controller', {'player': ev['es_username']}, playerlib.getPlayer(userid).get('lang')))

def item_pickup(ev):
	if not ev['item'] in (str(sv('unrestricted_ct_weapons')) if es.getplayerteam(ev['userid']) == 3 else str(sv('unrestricted_t_weapons'))):
		handle = es.getplayerhandle(ev['userid'])
		for index in es.createentitylist('weapon_%s'%ev['item']):
			if handle == es.getindexprop(index, "CBaseEntity.m_hOwnerEntity"):
				es.server.queuecmd('es_xremove %s'%index)
				es.tell(ev['userid'], '#multi', text('restricted weapon', {'weapon': ev['item']}, playerlib.getPlayer(ev['userid']).get('lang')))
				es.cexec(ev['userid'], 'lastinv')
				break

def player_spawn(ev):
	if int(sv('strip_weapons_on_round_end')):
		es.server.queuecmd('es_xgive %s player_weaponstrip'%ev['userid'])
		es.server.queuecmd('es_xfire %s player_weaponstrip strip'%ev['userid'])
		es.server.queuecmd('es_xfire %s player_weaponstrip kill'%ev['userid'])

	if es.getplayerteam(ev['userid']) == 2:
		for weapon in str(sv('t_start_weapons')).split(','):
			gamethread.delayed(0, es.server.queuecmd, 'es_xgive %s weapon_%s'%(ev['userid'], weapon))

	elif es.getplayerteam(ev['userid']) == 3:
		for weapon in str(sv('ct_start_weapons')).split(','):
			gamethread.delayed(0, es.server.queuecmd, ('es_xgive %s weapon_%s'%(ev['userid'], weapon)))

	if int(sv('hosties_enable_noblock')):
		es.setplayerprop(ev['userid'], 'CBaseEntity.m_CollisionGroup', 2)

def player_hurt(ev):
	if not playerlib.getPlayer(ev['userid']).get('isdead'):
		if not str(sv('hosties_announce_ct_hurt_t')) == '0':
			if es.getplayerteam(ev['attacker']) == 3:
				if es.getplayerteam(ev['userid']) == 2:
					Rb.check_rebel(int(ev['userid']))
					if not int(ev['userid']) in Rb.rebels:
						if str(sv('hosties_announce_ct_hurt_t')) == 'tell':
							es.tell(ev['userid'], '#multi', text('tell t attacked', {'attacker': es.getplayername(ev['attacker'])}, playerlib.getPlayer(ev['userid']).get('lang')))
						else:
							tokens = {'t': es.getplayername(ev['userid']), 'ct': es.getplayername(ev['attacker'])}
							for userid in es.getUseridList():
								es.tell(userid, '#multi', text('innocent attack', tokens, playerlib.getPlayer(userid).get('lang')))

		if not int(ev['attacker']) in Rb.rebels:
			if int(sv('hosties_rebel_on_hurt')):
				if es.getplayerteam(ev['userid']) == 3 and es.getplayerteam(ev['attacker']) == 2:
					if int(ev['attacker']) == LR.t and not int(ev['userid']) == LR.ct:
						LR.lastrequest = False
						for userid in es.getUseridList():
							es.tell(userid, '#multi', text('rebel', {'player': es.getplayername(ev['attacker'])}, playerlib.getPlayer(userid).get('lang')))
						Rb.rebels.append(int(ev['attacker']))

						if not str(sv('hosties_rebel_color')) == '0':
							playerlib.getPlayer(ev['attacker']).set('color', str(sv('hosties_rebel_color')).split(','))

					elif not int(ev['attacker']) == LR.t:
						if not int(ev['attacker']) in Rb.on_heads:
							for userid in es.getUseridList():
								es.tell(userid, '#multi', text('rebel', {'player': es.getplayername(ev['attacker'])}, playerlib.getPlayer(userid).get('lang')))
							Rb.rebels.append(int(ev['attacker']))

							if not str(sv('hosties_rebel_color')) == '0':
								playerlib.getPlayer(ev['attacker']).set('color', str(sv('hosties_rebel_color')).split(','))

### Popup Selects ###

def ws_select(userid, choice, popupid):
	for s in ['x', 'y', 'z']:
		sv(s).set(0)
	es.server.queuecmd('est_getviewcoord %s x y z'%userid)
	gamethread.delayed(0.06, ws_check, userid)

def ws_check(userid):
	playerlib.getPlayer(userid).set('freeze', 1)
	x, y, z = playerlib.getPlayer(userid).get('viewangle')
	x2, y2, z2 = [float(sv(w)) for w in ['x', 'y', 'z']]

	for s in ['x', 'y', 'z']:
		sv(s).set(0)

	x3, y3, z3 = es.getplayerlocation(userid)
	LR.w1 = x, y, z
	LR.w3 = math.sqrt(math.pow(x2 - x3, 2) + math.pow(y2 - y3, 2))

	es.server.queuecmd('es_xsetang %s %s %s %s'%(userid, x, y + 180, z))
	for a in [0, 0.03, 0.06, 0.09, 0.12, 0.15, 0.18, 0.21, 0.24, 0.27]:
		gamethread.delayed(a, es.server.queuecmd, ('es_xsetang %s %s %s %s'%(userid, x, y + 180, z)))
	gamethread.delayed(0.15, ws_check2, userid)

def ws_check2(userid):
	for s in ['x', 'y', 'z']:
		sv(s).set(0)
	es.server.queuecmd('est_getviewcoord %s x y z'%userid)
	gamethread.delayed(0.15, ws_check3, userid)

def ws_check3(userid):
	playerlib.getPlayer(userid).set('noclip', 0)
	LR.ws_startingpoint = es.getplayerlocation(userid)
	x2, y2, z2 = [float(sv(w)) for w in ['x', 'y', 'z']]
	x3, y3, z3 = es.getplayerlocation(userid)
	LR.w2 = playerlib.getPlayer(userid).get('viewangle')
	LR.w4 = math.sqrt(math.pow(x2 - x3, 2) + math.pow(y2 - y3, 2))
	if LR.w3 <= 550 or LR.w4 <= 550:
		lang = playerlib.getPlayer(userid).get('lang')
		es.tell(userid, '#multi', text('not enough room', {}, lang))
		es.tell(userid, '#multi', text('not enough room2', {}, lang))
		es.tell(userid, '#multi', text('not enough room3', {'d1': LR.w3, 'd2': LR.w4}, lang))
		LR.w1 = 0
		LR.w2 = 0
		popuplib.send('Choose WS', userid)
		return

	LR.WS_start()

def issue_select(userid, choice, popupid):
	issue2_menu = popuplib.easymenu('Simon Says', '_popup_choice', issue2_select)
	if int(sv('hosties_control_allow_simon')):
		issue2_menu.addoption([choice, 'With Simon'], text('With Simon', {}, menu_lang))
	issue2_menu.addoption([choice, 'Without Simon'], text('Without Simon', {}, menu_lang))
	popuplib.send('Simon Says', userid)

def issue2_select(userid, choice, popupid):
	CTRL.issue_order(userid, choice[0], (True if choice[1] == 'With Simon' else False))

def control_select(userid, choice, popupid):
	if choice == 'Issue Command':
		if not userid == CTRL.controller:
			es.tell(userid, '#multi', text('not controller', {}, playerlib.getPlayer(userid).get('lang')))
			return
		popuplib.send('Issue Command', userid)

	elif choice == 'Become Controller':
		CTRL.take_control(userid)

	elif choice == 'Stop Controlling':
		CTRL.stop_control(userid)

def pmenu_select(userid, choice, popupid):
	p = choice[1].lower()
	v = choice[0]
	if p == 'forgive':
		es.tell(v, '#multi', text('forgive', {'forgiver': es.getplayername(userid)}, playerlib.getPlayer(v).get('lang')))
		return

	elif p == 'burn':
		es.server.queuecmd('es_xfire %s !self ignite'%v)

	elif p.startswith('freeze'):
		playerlib.getPlayer(v).set('freeze', 1)
		gamethread.delayedname(int(p.replace('freeze', '')), 'freeze %s', playerlib.getPlayer(v).set, ('noclip', 0))

	elif p.startswith('slap'):
		playerlib.getPlayer(v).set('health', max(0, playerlib.getPlayer(v).get('health') - int(p.replace('slaphealth', ''))))

	elif p == 'slay':
		es.server.queuecmd('est_slay %s'%v)

	es.tell(v, '#multi', text('punish', {'punisher': es.getplayername(userid)}, playerlib.getPlayer(v).get('lang')))

def gunmenu_select(userid, choice, popupid):
	gunmenu = popuplib.easymenu('Current Guns', '_popup_choice', gunmenu_select)
	gunmenu.addoption(choice, 'Primary: %s'%playerlib.getPlayer(choice).get('primary'))
	gunmenu.addoption(choice, 'Secondary: %s'%playerlib.getPlayer(choice).get('secondary'))
	popuplib.send('Current Guns', userid)

def checkplayer_select(userid, choice, popupid):
	pass

def lrmenu_select(userid, choice, popupid):
	if LR.can_lr(userid):
		choseplayer = popuplib.easymenu('Chose Player', '_popup_choice', choseplayer_select)
		for userid2 in playerlib.getUseridList('#ct,#alive'):
			choseplayer.addoption([choice, userid2], es.getplayername(userid2))
		popuplib.send('Chose Player', userid)

accepted = []
def choseplayer_select(userid, choice, popupid):
	if not es.exists('userid', choice[1]):
		es.tell(userid, text('target left server', {}, playerlib.getPlayer(userid).get('lang')))
		return

	if playerlib.getPlayer(choice[1]).get('isdead'):
		es.tell(userid, '#multi', text('target dead', {}, playerlib.getPlayer(userid).get('lang')))
		return

	if LR.can_lr(userid):
		ma = False
		if int(sv('hosties_must_accept_lr')) and not userid in accepted:
			ma = True

		if not userid in Rb.rebels or not int(sv('hosties_make_ct_accept_lr_with_rebel')) and not ma:
			LR.t = userid
			LR.ct = choice[1]
			LR.lastrequest = {'Shot For Shot': 'S4S', 'Gun Toss': 'GT', 'Chicken Fight': 'CF', 'Knife Fight': 'KF', 'Race': 'Race', 'Western Shootout': 'WS'}[choice[0]]
			if int(sv('hosties_change_lr_colors')):
				playerlib.getPlayer(userid).set('color', [255, 0, 0, 255])
				playerlib.getPlayer(choice[1]).set('color', [0, 0, 255, 255])
			lrfuncs[choice[0]]()
		else:
			es.tell(userid, '#multi', '#lightgreen[Hosties]: #defaultasking #lightgreen%s#default to accept your Last Request...'%es.getplayername(choice[1]))
			alr = popuplib.easymenu('Accept LR', '_popup_choice', alr_select)
			alr.addoption([userid, choice[0], 'Yes'], text('yes', {}, menu_lang))
			alr.addoption([userid, choice[0], 'No'], text('no', {}, menu_lang))
			es.tell(choice[1], '#multi', text('marked as rebel' if not ma else 'accept lr', {'player': es.getplayername(userid)}, playerlib.getPlayer(choice[1]).get('lang')))
			popuplib.send('Accept LR', choice[1])

def alr_select(userid, choice, popupid):
	if choice[2] == 'Yes':
		if choice[0] in Rb.rebels:
			Rb.rebels.remove(choice[0])
		accepted.append(choice[0])
		choseplayer_select(choice[0], [choice[1], userid], None)
		accepted.remove(choice[0])
		return
	es.tell(choice[0], '#multi', text('declined request', {'player': es.getplayername(userid)}, playerlib.getPlayer(choice[0]).get('lang')))

def rules_select(userid, choice, popupid):
	popuplib.send('Rules', userid)

def hosties_select(userid, choice, popupid):
	popuplib.send(choice, userid)

def command_select(userid, choice, popupid):
	replies = {
		'!lr': 'Type !lr to get your last request if you\'re one of the last Ts!',
		'!rules': 'Type !rules to see the rules/how to play menu',
		'!commands': 'Show this menu',
		'!hosties': 'Show the main menu',
		'!checkplayers': 'Check to see if T\'s are rebelers or not',
		'!setpoints': 'If you\'re the t making points for the race, and you close your menu type this',
		'!control': 'Allows CTs to play a sort of simon says with Ts',
		'!wspoint': 'If you\'re the t making a point in the western shootout and you close your menu, type this',
	}
	es.tell(userid, '#multi', '#lightgreen[Hosties]: #default' + replies[choice])

def sp1_select(userid, choice, popupid):
	if LR.can_lr(userid, False):
		LR.start1 = es.getplayerlocation(userid)
		LR.race_effects()
		popuplib.send('Chose Spawn 2', userid)

def sp2_select(userid, choice, popupid):
	if LR.can_lr(userid, False):
		x, y, z = es.getplayerlocation(userid)
		x2, y2, z2 = LR.start1
		x3, y3, z3 = x - x2, y - y2, z - z2
		if 80 >= math.sqrt(math.pow(z3,2) + math.pow(y3,2)) >= 30 and abs(z - z2) <= 50:
			LR.start2 = x, y, z
			popuplib.send('Chose End Point', userid)
		else:
			es.tell(userid, '#multi', text('invalid race spacing', {'distance': math.sqrt(math.pow(z3,2) + math.pow(y3,2))}, playerlib.getPlayer(userid).get('lang')))
			popuplib.send('Chose Spawn 2', userid)

def race_end_select(userid, choice, popupid):
	if LR.can_lr(userid, False):
		x, y, z = es.getplayerlocation(userid)
		x2, y2, z2 = LR.start1
		x3, y3 = x - x2, y - y2
		if math.sqrt(math.pow(x3, 2) + math.pow(y3, 2)) >= 400:
			LR.race_end = x, y, z
			LR.start_race()
		else:
			es.tell(userid, '#multi', text('race locations too close', {}, playerlib.getPlayer(userid).get('lang')))
			popuplib.send('Chose End Point', userid)

### Misc ###

def _restrict_weapons(userid, args):
	if args[0].lower() in ['buy', 'jointeam', 'drop']:
		if args[0].lower() == 'buy':
			if not args[1].lower() in (str(sv('unrestricted_ct_weapons')) if es.getplayerteam(userid) == 3 else str(sv('unrestricted_t_weapons'))):
				return False

		elif args[0].lower() == 'jointeam':
			if args[1] == '3':
				if es.getplayersteamid(userid) in Rb.trounds:
					es.tell(userid, '#multi', text('rounds as t', {'rounds': Rb.trounds[es.getplayersteamid(userid)]}, playerlib.getPlayer(userid).get('lang')))
					return False

				if es.getplayercount(3) - es.getplayercount(2) >= int(sv('hosties_max_more_cts')):
					es.tell(userid, '#multi', text('too many cts', {}, playerlib.getPlayer(userid).get('lang')))
					return False

		elif args[0].lower() == 'drop':
			if userid in [LR.t, LR.ct] and LR.lastrequest == 'GT':
				if playerlib.getPlayer(userid).get('weapon') == 'weapon_deagle':
					if userid in LR.deaglecoords:
						if LR.deaglecoords[userid]:
							if int(sv('hosties_stop_double_drop')):
								es.tell(userid, '#multi', text('already thrown', {}, playerlib.getPlayer(userid).get('lang')))
								return False
					i = playerlib.getPlayer(userid).get('weaponindex', 'deagle')
					LR.deagle_loop(userid, i)
	return True

def set_rules():
	rulemenu = popuplib.easymenu('Rules', '_popup_choice', rules_select)
	for rule in hostie_rules:
		rulemenu.addoption(rule, rule)

def stop_lrs():
	LR.lastrequest = False
	LR.t = None
	LR.lrwinner = None
	LR.w1 = 0
	LR.w2 = 0
	LR.wsdone = []
	LR.ws_startingpoint = []
	for userid in es.getUseridList():
		gamethread.cancelDelayed('beacon_%s'%userid)

	for one in ['primary', 'secondary']:
		if one in LR.ct_weapons:
			if LR.ct_weapons[one]:
				es.server.queuecmd('es_xgive %s weapon_%s'%(LR.ct, LR.ct_weapons[one]))
	LR.ct = None
	LR.ct_weapons = {}

### Commands ###

def return_random_t_spawn(ct=False):
	for spawn in es.createentitylist('info_player_%sterrorist'%('counter' if ct else '')):
		x, y, z = map(float, es.getindexprop(spawn, 'CBaseEntity.m_vecOrigin').split(','))
		count = 0
		for userid in playerlib.getUseridList('#alive'):
			x2, y2, z2 = es.getplayerlocation(userid)
			if abs(x - x2) >= 30 and abs(y - y2) >= 30 and abs(z - z2) >= 30:
				count += 1

		if count == len(playerlib.getUseridList('#alive')):
			return x, y, z

	return x, y, z

def hosties_rule():
	args = es.getargs()

	if not args:
		es.dbgmsg(0, 'Need more args to add rules!')
		return

	hostie_rules.append(args)
	set_rules()

def hosties_addpun():
	if es.getargs():
		if len(es.getargs().split(' ')) < 2:
			es.dbgmsg(0, 'Not enough arguments for hosties_addpunishment!')
			return
		Rb.add_punishment(es.getargs().split(' '))

def add_menu_punishment():
	if es.getargc() < 3:
		es.dbgmsg(0, 'Syntax Error: hosties_add_menu_punishment <kills> <punishment>')
		return

	args = es.getargs().split(' ')
	tmik[args[0]] = args[1]
